using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Web.Script.Serialization;
using System.Collections.Generic;
using ComplexType;

namespace Converter
{

	public class BoyConverter : JavaScriptConverter
	{
		public override object Deserialize(IDictionary<string, object> dictionary, Type type, JavaScriptSerializer serializer)
		{
			Boy boy = new Boy();
			boy.Name = (string)dictionary["Name"];
			boy.GirlFriend = serializer.ConvertToType<Girl>(dictionary["GirlFriend"]);
			boy.GirlFriend.BoyFriend = boy;

			return boy;
		}

		public override IDictionary<string, object> Serialize(object obj, JavaScriptSerializer serializer)
		{
			Boy boy = (Boy)obj;
			IDictionary<string, object> result = new Dictionary<string, object>();

			result["Name"] = boy.Name;

			boy.GirlFriend.BoyFriend = null;
			result["GirlFriend"] = boy.GirlFriend;

			return result;
		}

		public override IEnumerable<Type> SupportedTypes
		{
			get
			{
				yield return typeof(Boy);
			}
		}
	}

}